/*$
Copyright (C) 2013-2016 Azel.

This file is part of AzPainter.

AzPainter is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

AzPainter is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
$*/

#ifndef _AZPT_GRADEDITDLG_H
#define _AZPT_GRADEDITDLG_H

#include "AXDialog.h"
#include "AXMem.h"

class AXLayout;
class AXLineEdit;
class AXCheckButton;
class AXColorButton;
class CValBar;
class CGradListItem;
class CGradEditDlg_edit;

class CGradEditDlg:public AXDialog
{
protected:
    CGradListItem   *m_pItem;

    AXLineEdit      *m_peditColPos,
                    *m_peditAPos;
    AXColorButton   *m_pbtCol;
    CValBar         *m_pbarA;
    AXCheckButton   *m_pckFlag[2],
                    *m_pckColType[3];
    CGradEditDlg_edit   *m_pgradCol,
                        *m_pgradA;

protected:
    void _setwidget_grad(AXLayout *plTop,UINT idTop,BOOL bAlpha);
    void _setCurVal_col();
    void _setCurVal_a();
    void _runGradMenu(BOOL bAlpha);
    void _setDat();

public:
    CGradEditDlg(AXWindow *pOwner,CGradListItem *pItem);

    BOOL isSingleCol();
    LPBYTE getAlphaBuf();

    virtual BOOL onNotify(AXWindow *pwin,UINT uNotify,ULONG lParam);
};

#endif
